<script lang="ts">
  import type {
    Expression,
    ExpressionOperator,
    ExpressionBody,
    ConstantBody,
    UnaryBody,
    BinaryBody,
    ListBody,
  } from '$lib';
  import Dropdown from '$lib/Dropdown.svelte';
  import ConstantElement from '$lib/ConstantElement.svelte';
  import DeleteButton from '$lib/DeleteButton.svelte';
  import Tiptap from '$lib/Tiptap.svelte';

  // Define props
  export let value: Expression;

  // When the expression operator changes, reset (or convert) its body
  let oldOperator = value.operator;

  $: handleOperatorChange(value.operator);

  function handleOperatorChange(newOperator: ExpressionOperator) {
    // Return if not changed
    if (newOperator === oldOperator) {
      return;
    }
    oldOperator = newOperator;

    // IMPROVE: convert the body instead of simply resetting it for the new operator
    switch (newOperator) {
      case 'always':
      case 'constant': {
        value.body = null as ConstantBody;
        break;
      }

      case 'input': {
        value.body = 'fscPeerId' as ConstantBody;
        break;
      }

      case 'data': {
        value.body = '' as ConstantBody;
        break;
      }

      case 'and':
      case 'or': {
        value.body = [
          {
            operator: 'always',
            body: null,
          },
        ] as ListBody;
        break;
      }

      case 'not': {
        value.body = {
          operator: 'constant',
          body: true,
        } as UnaryBody;
        break;
      }

      case '==':
      case '!=': {
        value.body = {
          left: {
            operator: 'constant',
            body: null,
          },
          right: {
            operator: 'constant',
            body: null,
          },
        } as BinaryBody;
        break;
      }

      case 'in': {
        value.body = {
          left: {
            operator: 'constant',
            body: null,
          },
          right: {
            operator: 'constant',
            body: [
              {
                operator: 'constant',
                body: null,
              },
            ] as ListBody,
          },
        } as BinaryBody;
        break;
      }

      case '<':
      case '<=':
      case '>':
      case '>=':
      case '+':
      case '-':
      case '*': {
        value.body = {
          left: {
            operator: 'constant',
            body: 0,
          },
          right: {
            operator: 'constant',
            body: 0,
          },
        } as BinaryBody;
        break;
      }

      case 'contains':
      case 'containsAll': {
        value.body = {
          left: {
            operator: 'constant',
            body: [
              {
                operator: 'constant',
                body: null,
              },
            ] as ListBody,
          },
          right: {
            operator: 'constant',
            body: null,
          },
        } as BinaryBody;
        break;
      }

      case 'matchesRegExp': {
        value.body = {
          left: {
            operator: 'constant',
            body: '',
          },
          right: {
            operator: 'constant',
            body: '',
          },
        } as BinaryBody;
        break;
      }
    }
  }

  function isConstantBody(bd: ExpressionBody): bd is ConstantBody {
    return (bd as ConstantBody) !== undefined;
  }

  function isListBody(bd: ExpressionBody): bd is ListBody {
    return (bd as ListBody) !== undefined;
  }

  function isBinaryBody(bd: ExpressionBody): bd is BinaryBody {
    return (bd as BinaryBody) !== undefined;
  }

  function isString(value: any): value is string {
    return typeof value === 'string';
  }

  function deleteListBodyItem(i: number): undefined {
    if (isListBody(value.body)) {
      value.body.splice(i, 1);
      value.body = value.body; // Re-render the elements
    }
  }
</script>

<p class="mb-3 last:mb-0">
  <Dropdown
    bind:value={value.operator}
    options={[
      { value: 'always', label: 'Altijd' },
      { value: 'constant', label: 'Constante' },
      { value: 'input', label: 'Input-waarde' },
      { value: 'data', label: 'Data-waarde' },
      { value: 'and', label: 'En' },
      { value: 'or', label: 'Of' },
      { value: 'not', label: 'Niet' },
      { value: '==', label: '==' },
      { value: '!=', label: '!=' },
      { value: 'in', label: 'Komt voor in' },
      { value: '<', label: '<' },
      { value: '<=', label: '<=' },
      { value: '>', label: '>' },
      { value: '>=', label: '>=' },
      { value: '+', label: '+' },
      { value: '-', label: '-' },
      { value: '*', label: '×' },
      { value: 'contains', label: 'Bevat' },
      { value: 'containsAll', label: 'Bevat alle' },
      { value: 'matchesRegExp', label: 'Matcht met reguliere expressie' },
    ]}
  />
</p>

{#if value.operator === 'constant'}
  {#if isConstantBody(value.body)}
    <ConstantElement bind:value={value.body} />
  {/if}
{:else if value.operator === 'input'}
  {#if isConstantBody(value.body) && typeof value.body === 'string'}
    Input-veld: <Dropdown
      bind:value={value.body}
      options={[
        { value: 'fscPeerId', label: 'FSC peer ID' },
        { value: 'requestHeaders', label: 'HTTP request headers' },
        { value: 'queryParameters', label: 'Query parameters' },
        // { value: 'requestBody', label: 'HTTP request body' },
        { value: 'routeParameters', label: 'Route parameters' },
      ]}
    />
  {/if}
{:else if value.operator === 'data'}
  {#if isString(value.body)}
    Data-veld (JSON path): <Tiptap
      bind:value={value.body}
      class="mb-2 inline-block w-80 rounded-lg border border-gray-300 p-2.5 align-middle text-gray-800 placeholder:text-gray-400 focus:border-indigo-500 focus:outline-none focus:ring-1 focus:ring-indigo-500"
      placeholder="Voorbeeld: users[0].name"
      autofocus
    />
    <p class="text-sm text-gray-500">
      Tip: het is mogelijk om hierbij input variabelen te gebruiken, bijvoorbeeld <span
        class="inline-block rounded bg-slate-500 px-1 py-0.5 font-mono text-xs text-white"
        >$fscPeerId</span
      >.
    </p>
  {/if}
{:else if value.operator === 'and' || value.operator === 'or'}
  {#if isListBody(value.body)}
    {#each value.body as _, i (i)}
      {#if i !== 0}
        <p class="my-3 text-center font-medium text-gray-500">
          {#if value.operator === 'and'}en{:else}of{/if}
        </p>
      {/if}
      <div class="rounded-md border border-slate-200 p-4">
        {#if value.body.length > 1}
          <DeleteButton on:click={deleteListBodyItem(i)} />
        {/if}
        <svelte:self bind:value={value.body[i]} />
      </div>
    {/each}

    <p class="mt-5">
      <button
        on:click={() => {
          if (isListBody(value.body)) {
            value.body = [
              ...value.body,
              {
                operator: 'always',
                body: null,
              },
            ];
          }
        }}
        class="inline-flex items-center rounded-lg border border-indigo-300 bg-indigo-50 px-2.5 py-1.5 text-sm font-medium text-indigo-800 shadow-sm hover:border-indigo-400 hover:bg-indigo-100 hover:text-indigo-950 focus:outline-none focus:ring-4 focus:ring-indigo-200"
        type="button"
      >
        <svg class="-ml-0.5 mr-2 h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
          <path
            fill="none"
            stroke="currentColor"
            stroke-linecap="round"
            stroke-linejoin="round"
            stroke-width="2"
            d="M12 5v14m-7-7h14"
          />
        </svg>
        {#if value.operator === 'and'}Voeg voorwaarde toe{:else}Voeg optie toe{/if}
      </button>
    </p>
  {/if}
{:else if value.operator === 'not'}
  <div class="rounded-md border border-slate-200 p-4">
    <svelte:self bind:value={value.body} />
  </div>
{:else if ['==', '!=', 'in', '<', '<=', '>', '>=', '+', '-', '*', 'contains', 'containsAll', 'matchesRegExp'].includes(value.operator)}
  {#if isBinaryBody(value.body)}
    <div class="rounded-md border border-slate-200 p-4">
      <svelte:self bind:value={value.body.left} />
    </div>
    <p class="my-3 text-center font-medium text-gray-500">
      {#if value.operator === 'in'}
        komt voor in
      {:else if value.operator === '*'}
        ×
      {:else if value.operator === 'contains'}
        bevat
      {:else if value.operator === 'containsAll'}
        bevat alle
      {:else if value.operator === 'matchesRegExp'}
        matcht met de reguliere expressie
      {:else}
        {value.operator}
      {/if}
    </p>
    <div class="rounded-md border border-slate-200 p-4">
      <svelte:self bind:value={value.body.right} />
    </div>
  {/if}
{/if}
